function f = igci(x,y,refMeasure,estimator)

% Copyright (c) 2010  Povilas Daniušis, Joris Mooij
% All rights reserved.  See the file COPYING for license terms.

% Note we have modified the code to work for our input and changed metrics for our case 
[m, dx] = size(x);

[m, dy] = size(y);

switch refMeasure
  case 2
    % Gaussian reference measure
    x = (x - mean(x)) ./ std(x);
    y = (y - mean(y)) ./ std(y);
end       
  
switch estimator
  case 1
    % difference of entropies

    [x1,indXs] = sort(x);
    [y1,indYs] = sort(y);

    n1 = length(x1);
    hx = 0.0;
    for i = 1:n1-1
      delta = x1(i+1)-x1(i);
      if delta
        hx = hx + log(abs(delta));
      end
    end
    hx = hx / (n1 - 1) + psi(n1) - psi(1);

    n2 = length(y1);
    hy = 0.0;
    for i = 1:n2-1
      delta = y1(i+1)-y1(i);
      if delta
        hy = hy + log(abs(delta));
      end
    end
    hy = hy / (n2 - 1) + psi(n2) - psi(1);

    f = hy - hx;
end

return
