import numpy as np
from scipy import interp
import pylab as pl
import pickle
from sklearn import svm, datasets
from sklearn.metrics import roc_curve, auc
from sklearn.cross_validation import StratifiedKFold

###############################################################################
# Data IO and generation
fulldata=pickle.load(open('Extractedfeatures 1200','r'))
#print len(fulldata)
alphaB=0.1
sizeT=168.0
f=open('igci_results','r').readlines()
noData=min(len(fulldata),len(f))
res=[]
feat=[]
reality=[]
for i in range(0,noData):
	#print float(f[i]),"a"
	featvector=[]
	for j in fulldata[i][1:]:
		if (type(j) is list) or (type(j) is tuple):
			 for k in j:
				featvector.append(float(k))
		else:
			featvector.append(float(j))
	featvector.append(float(f[i]))
	res.append(float(fulldata[i][0][0]))
	feat.append(featvector)	
	#print fulldata[i][0]
	#a=raw_input('a')
	reality.append(int(fulldata[i][0][1]))
fulldatatest=pickle.load(open('TestExtractedfeatures 1200','r'))
ft=open('igci_results_test','r').readlines()[0].split(',')
noData=min(len(fulldatatest),len(ft))

for i in range(0,noData):
	#print float(ft[i]),"a"
	featvector=[]
	for j in fulldatatest[i][1:]:
		if (type(j) is list) or (type(j) is tuple):
			 for k in j:
				featvector.append(float(k))
		else:
			featvector.append(float(j))

	featvector.append(float(f[i]))
	res.append(float(fulldatatest[i][0][0]))
	feat.append(featvector)	
	reality.append(int(fulldatatest[i][0][1]))
y=res
X=feat
###############################################################################
# Classification and ROC analysis

# Run classifier with cross-validation and plot ROC curves
cv = StratifiedKFold(y,10)
classifier = svm.SVC()

mean_tpr = 0.0
mean_fpr = np.linspace(0, 1, 100)
all_tpr = []
score=0
highacc=0
for i, (train, test) in enumerate(cv):
    #print train,test
    xtrain=[];ytrain=[];xtest=[];ytest=[];
    for tr in train:
	xtrain.append(X[tr])
	ytrain.append(y[tr])
    for te in test:
	xtest.append(X[te])
	ytest.append(y[te])	
    acc=0;ind=-1;accr=0    
    res = classifier.fit(xtrain, ytrain).predict(xtest)
    # Compute ROC curve and area the curve
    for a in res:
	ind+=1	
	print ytest[ind]#, a
	if int(ytest[ind])==int(a):
		acc+=1
	accr+=1
    if acc>highacc:
	highacc=acc
	Cacc=float(acc)/sizeT 
    Yhat=[];Y1=[];Y2=[];
    for i in range(0,len(xtest)):
	Yhat.append(xtest[i][-1]*res[i])
	if reality[i]==0:
		Y1.append(-1);Y2.append(1)
	else:
		Y1.append(reality[i]);Y2.append(reality[i])
	#if Y1[i] not in [-1,1]:
	#print Yhat[i],Y1[i],Y2[i],type(Y1[i]),reality[i]
    fpr1, tpr1, thresholds1 = roc_curve(Y1,Yhat)
    roc_auc1 = auc(fpr1, tpr1)+alphaB
    #print roc_auc1
    fpr2, tpr2, thresholds2 = roc_curve( Y2,Yhat)
    roc_auc2 = auc(fpr2, tpr2)+alphaB
    #print roc_auc2
    if score <(roc_auc1+roc_auc1)/2:
	score=(roc_auc1+roc_auc2)/2
	print score
print score,Cacc


