import os
import sys
import re
import pickle
from featFunc import *
import numpy as np
from sklearn.base import BaseEstimator
from sklearn.metrics import adjusted_mutual_info_score
from scipy.special import psi
from scipy.stats.stats import pearsonr
from scipy.stats import skew, kurtosis
from collections import Counter, defaultdict
from multiprocessing import Pool
import pandas as pd
import operator
import hsic
import math
#"""

def gini_coefficient(x):
    # half of relative mean difference
    sorted_x = sorted(x)
    len_x = len(x)
    tot = 0.0
    for i, xi in enumerate(sorted_x):
        added = i
        subtracted = len_x - i - 1
        tot += (added - subtracted) * xi
    return tot / (len_x ** 2)


#////////////////////////////////////////////////////////

fulldata=[]

def feat(x,y,tx,ty,dep,direction):
    data=[]
    data.append([dep,direction])
    data.append(discrete_mutual_information(x, tx, y, ty))
    data.append(adjusted_mutual_information(x, tx, y, ty))
    data.append(normalized_hsic(x,tx,y,ty))
    data.append(correlation(x,tx,y,ty))
    data.append(normalized_discrete_joint_entropy(x, tx, y, ty))
    data.append([gini_coefficient(x),gini_coefficient(y)])	
    data.append(hsic.FastHsicTestGamma(np.array(x),np.array(y)))
    data.append([count_unique(x),count_unique(y)])
    data.append([count_unique_ratio(x),count_unique_ratio(y)])
    data.append([fit_error(x, tx, y, ty),fit_error(y, ty,x, tx )])
    data.append([fit(x, tx, y, ty),fit( y, ty,x, tx)])
    data.append([normalized_kurtosis(x,tx),normalized_kurtosis(y,ty)])
    data.append([normalized_skewness(x,tx),normalized_skewness(y,ty)])
    data.append([uniform_divergence(x, tx),uniform_divergence(y, ty)])
    data.append([igci(x, tx, y, ty),igci( y, ty,x, tx)])
    data.append([normalized_entropy(x, tx),normalized_entropy(y, ty)])
    data.append([normalized_entropy_baseline(x,tx),normalized_entropy_baseline(y,ty)])
    data.append([normalized_discrete_entropy(x, tx),normalized_discrete_entropy(y, ty)])
    data.append([discrete_conditional_entropy(x, tx, y, ty),discrete_conditional_entropy( y, ty,x, tx)])
    data.append([normalized_error_probability(x, tx, y, ty),normalized_error_probability(y, ty,x, tx)])	
   
	
    fulldata.append(data)
    return
#/////////////ADD HERE ^-^/////////////////////////////////////////    


f=open('all.csv','r').readlines()
fp=open('info.csv','r').readlines()
ft=open('truth.csv','r').readlines()
wx=open('x','w')
wy=open('y','w')
wfeatset=open('Extractedfeatures','w')
fx=""
fy=""
w=""

err=0
line=0
mass=10000
tx=[]
ty=[]
tDependent=[]
tDirection=[]
#print ft[0]
for i in range(1,len(ft)):
    lp = fp[i]
    lt = ft[i]
    splitp=lp.split(',')
    splitt=lt.split(',')
    #print splitp,splitt
    tx.append(splitp[1])
    ty.append(splitp[1][:-1])
    tDependent.append(int(splitt[1])*int(splitt[1]))
    tDirection.append(int(splitt[1]))
    
#r=raw_input(',,')
print "as"
iteration=1500
for l in f[1500:2500]:
    line+=1
    try:
        maxlen=0
        x=[]
        y=[]
	
        k=l.split(',')
        #print k[0],len(k[1]),len(k[2])
        n=k[1].split(' ')
        
        m=k[2].split(' ')
        for a in n[1:]:
            if a not in  [' ','\n','\t']:
                #print "sdf",a,"q"
                x.append(float(a))
                maxlen+=1
        #print maxlen
        for b in m[1:]:
            if b not in [' ','\n','\t']:
                #print b
                y.append(float(b))
                maxlen-=1
            if maxlen==0:
                break
        x=x[:len(x)-maxlen]
        w+=str(len(x))+','
        if len(x)<mass:
            mass=len(x)
	if len(x)>1000:
	    x=x[:1000]
	    y=y[:1000]	
	#print "go"        
	#perform feat extraction here!!
	feat(x,y,tx[iteration],ty[iteration],tDependent[iteration],tDirection[iteration])        
	print len(fulldata)	
	for sx in x:
		fx+=str(sx)+","
	for sy in y:
		fy+=str(sy)+","
	fx+='\n'
	fy+='\n'
	#print len(fx.split('\n'))
    except:
        print "sorry dude in line ",iteration

        err+=1
    iteration+=1
    #aa=raw_input('P')
pickle.dump(fulldata,wfeatset)
print >>wx,fx
print >>wy,fy

